1 两数之和

给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那两个整数,并返回他们的数组下标。
你可以假设每种输入只会对应一个答案。但是,你不能重复利用这个数组中同样的元素。

给定 nums = [2, 7, 11, 15], target = 9
因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]

一,暴力法,直接两个for循环

    class Solution {
        public int[] twoSum(int[] nums, int target) {
             for(int i=0;  i<nums.length;  i++)
            {
                for(int j=i+1;  j<nums.length;  j++)
                {
                    if(nums[j] + nums[i]  ==  target)
                    {
                        return new int[] { i, j };
                    }
                }
            }
            throw new IllegalArgumentException("sorry,No two sums");
            
        }
    }

方法一时间复杂度是O(n^2), 下面我们用哈希表来降低时间复杂度!

二,哈希映射

思路:

  1. 由于哈希查找的时间复杂度为O(1),所以可以利用哈希容器map降低时间复杂度;
  2. 遍历数组nums,i为当前下标,每个值都判断map中是否存在target-nums[i]的key值;
  3. 如果存在则找到了两个值,如果不存在则将当前的(nums[i], i)存入map中,继续遍历直到找到为止;
  4. 如果最终都没有结果则抛出异常。

时间复杂度是O(n)

class Solution {
    public int[] twoSum(int[] nums, int target) {
        Map<Integer, Integer> map = new HashMap<>();
        for (int i=0; i<nums.length; i++){
            int key = target - nums[i];
            if (map.containsKey(key)){
                return new int [] {map.get(key),  i};    // 返回符合条件的数组
            }
            map.put(nums[i], i);  //将数组的值以键值对的形式存储到Map中
        }
        throw new IllegalArgumentException("No two sum solution");
        
    }
}

有问题欢迎留言哦

参考:

https://leetcode-cn.com/problems/two-sum/solution/

https://draw.mdnice.com/algorithm/1.html

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值